(**********************************************
  Copyright CoSyDat Sofware Engineering
  Delphi 4 Library Package: "CSD List-Printer"
**********************************************)

unit ListPrinterReg;

interface

uses Windows, Messages, SysUtils, Classes, DsgnIntf, Graphics, Controls, Forms,
     Dialogs, StdCtrls, TypInfo, LPKernel, ActnList, DBGridPrt, ListViewPrt,
     ListViewActions, LPKToolBar, RichEditPrt, MemoPrt, StringGridPrt, TextReportPrt;

{$R ListPrinter.dcr}

type
  TFriendlyFmtDlg = class(TForm)
    Edit: TEdit;
    List: TListBox;
    btnOK: TButton;
    btnCancel: TButton;
    procedure ListDblClick(Sender: TObject);
  private
  public
  end;

  TFriendlyFormatProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

procedure Register;

implementation

{$R *.DFM}

{============ TFriendlyFmtDlg ============}

procedure TFriendlyFmtDlg.ListDblClick(Sender: TObject);
var S: String;
begin
  S := Copy(List.Items[List.ItemIndex], 1, 2);
  if S <> '--' then Edit.SelText := S;
  if Edit.CanFocus then Edit.SetFocus;
end;

{============ TFriendlyFormatProperty ============}

procedure TFriendlyFormatProperty.Edit;
var FriendlyFmtDlg: TFriendlyFmtDlg;
begin
  FriendlyFmtDlg := TFriendlyFmtDlg.Create(Application);
  try
    FriendlyFmtDlg.Edit.Text := GetStrValue;
    If FriendlyFmtDlg.ShowModal = mrOk then SetStrValue(FriendlyFmtDlg.Edit.Text);
  finally
    FriendlyFmtDlg.Free;
  end;
end;

function TFriendlyFormatProperty.GetAttributes: TPropertyAttributes;
begin
  Result := (inherited GetAttributes) + [paDialog];
end;

procedure Register;
begin
  RegisterActions('ListView',   [TListViewInsert, TListViewDelete,
                                 TListViewStepUp, TListViewStepDown,
                                 TImportListView, TExportListView], nil);
  RegisterComponents('CoSyDat', [TDBGridPrint, TListViewPrint, TLPToolBar,
                                 TRichEditPrint, TMemoPrint, TStringGridPrint,
                                 TTextReportPrint]);
  RegisterPropertyEditor(TypeInfo(String), TTextReportPrint, 'FriendlyHeader', TFriendlyFormatProperty);
  RegisterPropertyEditor(TypeInfo(String), TTextReportPrint, 'FriendlyFooter', TFriendlyFormatProperty);
end;

end.
