unit SzListEd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, DsgnIntf, ExtCtrls, Menus, Grids, TabShp;

type
  TSizeListPropEditor = class(TPropertyEditor)
    function GetAttributes:TPropertyAttributes;override;
    function GetValue:string;override;
    procedure Edit;override;
  end;

  TSizeListDlg = class(TForm)
    btOk: TButton;
    btCancel: TButton;
    sgValues: TStringGrid;
    popSizePE: TPopupMenu;
    pmiAdd: TMenuItem;
    pmiDel: TMenuItem;
    procedure pmiAddClick(Sender: TObject);
    procedure pmiDelClick(Sender: TObject);
    procedure sgValuesSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SizeListDlg: TSizeListDlg;

procedure Register;

implementation

{$R *.DFM}

procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(TSizeList),nil,'',TSizeListPropEditor);
end;


{ TSizeListPropEditor }

procedure TSizeListPropEditor.Edit;
var Dialog:TSizeListDlg;

    function StrToSize(SStr:TStrings):TSizeList;
    var i:integer;
    begin
      Result:=TSizeList.Create;
      for i:=0 to SStr.Count-1 do
        Result.Add(StrToInt(SStr[i]));
    end;

    function SizeToStr(SSize:TSizeList):TStrings;
    var i:integer;
    begin
      Result:=TStringList.Create;
      for i:=0 to SSize.Count-1 do
        Result.Add(IntToStr(SSize[i]));
    end;

begin
  Dialog:=TSizeListDlg.Create(Application);
  try
    Dialog.Caption:=GetComponent(0).GetNamePath+'.'+GetName;
    Dialog.sgValues.RowCount:=TSizeList(GetOrdValue).Count;
    Dialog.sgValues.Cols[0].AddStrings(SizeToStr(TSizeList(GetOrdValue)));
    if Dialog.ShowModal=mrOk then
      begin
        TSizeList(GetOrdValue).Clear;
        SetOrdValue(Integer(StrToSize(Dialog.sgValues.Cols[0])));
      end;
  finally
    Dialog.Free;
  end;

end;

function TSizeListPropEditor.GetAttributes: TPropertyAttributes;
begin
  Result:= [paDialog];
end;

function TSizeListPropEditor.GetValue: string;
begin
  Result:=Format('(%s)',[GetPropType^.Name]);
end;

procedure TSizeListDlg.pmiAddClick(Sender: TObject);
begin
  sgValues.RowCount:=sgValues.RowCount+1;
  sgValues.Cells[0,pred(sgValues.RowCount)]:=IntToStr(0);
  pmiDel.Enabled:=True;
end;

procedure TSizeListDlg.pmiDelClick(Sender: TObject);
var tmpStrs:TStrings;
    Idx:Integer;
begin
  Idx:=sgValues.Row;
  tmpStrs:=TStringList.Create;
  tmpStrs.AddStrings(sgValues.Cols[0]);
  tmpStrs.Delete(Idx);
  sgValues.Cols[0].Clear;
  sgValues.RowCount:=sgValues.RowCount-1;
  sgValues.Cols[0].Assign(tmpStrs);
  pmiDel.Enabled:=sgValues.RowCount>0;
end;

procedure TSizeListDlg.sgValuesSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
const sIntKeys = '0123456789';
var nIdx: Integer;
begin
  nIdx := StrLen(pchar(Value));
  // only allow numbers to be entered
  for nIdx := 1 to nIdx do
    if StrScan(sIntKeys, char(Value[nIdx])) = nil then
      begin
        sgValues.Cells[ACol, ARow]:='0';
        Break;
      end;
end;

end.
