unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, Grids, DBGrids, ExtCtrls, DBCtrls, TeeProcs, TeEngine,
  Chart, StdCtrls, Series, DBChart, kbmMemTable, DBTables, ComCtrls, kbmCompress;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    kbmMemTable1: TkbmMemTable;
    kbmMemTable1PERIOD: TIntegerField;
    kbmMemTable1VALUE: TIntegerField;
    kbmMemTable1COLOR: TIntegerField;
    kbmMemTable1CALC: TStringField;
    Table1: TTable;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button1: TButton;
    Panel2: TPanel;
    DBImage1: TDBImage;
    DBMemo1: TDBMemo;
    TabSheet2: TTabSheet;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    TabSheet3: TTabSheet;
    Button11: TButton;
    Label10: TLabel;
    btnLocatePeriod: TButton;
    eSearch: TEdit;
    btnLocateValue: TButton;
    chbCaseInsensitive: TCheckBox;
    chbPartialKey: TCheckBox;
    btnLookupCalc: TButton;
    btnLocateCalc: TButton;
    TableFilteredCheckBox: TCheckBox;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    eResult: TEdit;
    TabSheet4: TTabSheet;
    tMaster: TTable;
    DBGrid2: TDBGrid;
    dsMaster: TDataSource;
    Panel3: TPanel;
    Button12: TButton;
    tDetailTemplate: TTable;
    Label18: TLabel;
    chbDescending: TCheckBox;
    Label19: TLabel;
    lblLZH: TLabel;
    PageControl2: TPageControl;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    Label1: TLabel;
    Button9: TButton;
    Button2: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Button3: TButton;
    Label4: TLabel;
    Button4: TButton;
    Button5: TButton;
    Label5: TLabel;
    Memo1: TMemo;
    Panel4: TPanel;
    LZHCompressed: TCheckBox;
    Label11: TLabel;
    Button10: TButton;
    BlobCompression: TCheckBox;
    Label20: TLabel;
    Label21: TLabel;
    BinarySave: TCheckBox;
    cbSortField: TComboBox;
    kbmMemTable1Date: TDateField;
    btnSetRange: TButton;
    Label22: TLabel;
    Label23: TLabel;
    btnCancelRange: TButton;
    Label24: TLabel;
    btnFindNearest: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure MemTable1CalcFields(DataSet: TDataSet);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure kbmMemTable1FilterRecord(DataSet: TDataSet;
      var Accept: Boolean);
    procedure TableFilteredCheckBoxClick(Sender: TObject);
    procedure btnLocatePeriodClick(Sender: TObject);
    procedure btnLocateCalcClick(Sender: TObject);
    procedure btnLocateValueClick(Sender: TObject);
    procedure btnLookupCalcClick(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure kbmMemTable1CompressBlobStream(UnCompressedStream,
      CompressedStream: TStream);
    procedure kbmMemTable1DecompressBlobStream(CompressedStream,
      DeCompressedStream: TStream);
    procedure kbmMemTable1CompressSave(UnCompressedStream,
      CompressedStream: TStream);
    procedure kbmMemTable1DecompressLoad(CompressedStream,
      DeCompressedStream: TStream);
    procedure TabSheet3Enter(Sender: TObject);
    procedure btnSetRangeClick(Sender: TObject);
    procedure btnCancelRangeClick(Sender: TObject);
    procedure btnFindNearestClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
   i:integer;
begin
     with kbmMemTable1 do
     begin
          Close;
          Open;
          for i:=1 to 100 do
          begin
               Append;
               FieldByName('PERIOD').asinteger:=i;
               FieldByName('VALUE').asinteger:=i * 2;
               FieldByName('COLOR').asinteger:=i * 4;
               FieldByName('Date').AsDateTime:=Now+i-1;
               Post;
          end;
     end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     if BinarySave.Checked then
        kbmMemTable1.SaveToBinaryFile('c:\test.csv',[mtfSaveData, mtfSaveCalculated, mtfSaveBlobs, mtfSaveDef])
     else
         kbmMemTable1.SaveToFile('c:\test.csv',[mtfSaveData, mtfSaveCalculated, mtfSaveBlobs, mtfSaveDef]);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     kbmMemTable1.Open;
     kbmMemTable1.EmptyTable;
     if BinarySave.Checked then
        kbmMemTable1.LoadFromBinaryFile('c:\test.csv')
     else
         kbmMemTable1.LoadFromFile('c:\test.csv');
end;

procedure TForm1.MemTable1CalcFields(DataSet: TDataSet);
var
   i:integer;
   s:string;
begin
     if kbmMemTable1.Fields[0].IsNull then
        kbmMemTable1.Fields[3].AsString:='NULL'
     else
     begin
          i:=kbmMemTable1.Fields[0].AsInteger;
          s:=LongMonthNames[(i mod 12) + 1];
          kbmMemTable1.Fields[3].AsString := kbmMemTable1.Fields[0].AsString + '-' + s;
     end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
     Memo1.Lines.Text:=kbmMemTable1.CommaText;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
     kbmMemTable1.CommaText:=Memo1.Lines.Text;
end;

// Dynamically define a set of fields.

procedure TForm1.Button6Click(Sender: TObject);
begin
     with kbmMemTable1, kbmMemTable1.FieldDefs do
     begin
          Close;
          Clear;
          MasterSource:=nil;
          Add('Period', ftInteger, 0, false);
          Add('VALUE', ftInteger, 0, false);
          Add('Color', ftInteger, 0, false);
          Add('CALC', ftString, 20, false);
          Add('Date', ftDate, 0, false);
          IndexFields := 'VALUE';
          SortFields := 'VALUE';
          CreateTable;
     end;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
     kbmMemTable1.Open;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
     kbmMemTable1.Close;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
     with kbmMemTable1 do
     begin
          IndexFields:='';
          SortFields:='';
          MasterSource:=nil;
          LoadFromDataSet(Table1, true, true);
     end;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
     DBImage1.DataField:='graphic';
     DBMemo1.DataField:='Notes';
end;

procedure TForm1.Button11Click(Sender: TObject);
var
   Options:TkbmMemTableCompareOptions;
begin
     Options := [];
     if chbDescending.Checked then Options:=Options + [mtcoDescending];
     if chbCaseInsensitive.Checked then Options:=Options + [mtcoCaseInsensitive];
     kbmMemTable1.SortOn(cbSortField.Text, Options);
end;

procedure TForm1.kbmMemTable1FilterRecord(DataSet: TDataSet;
  var Accept: Boolean);
begin
     Accept:=DataSet.FieldByName('Period').AsInteger > 10;
end;

procedure TForm1.TableFilteredCheckBoxClick(Sender: TObject);
begin
     DataSource1.DataSet.Filtered:=TCheckBox(Sender).Checked;
     DataSource1.DataSet.Refresh;
end;

procedure TForm1.btnLocatePeriodClick(Sender: TObject);
begin
     DataSource1.DataSet.Locate('PERIOD', eSearch.Text, []);
end;

procedure TForm1.btnLocateCalcClick(Sender: TObject);
var
   Options:TLocateOptions;
begin
     Options:=[];
     if chbCaseInsensitive.Checked then Include(Options,loCaseInsensitive);
     if chbPartialKey.Checked then Include(Options,loPartialKey);
     DataSource1.DataSet.Locate('CALC', eSearch.Text, Options);
end;

procedure TForm1.btnLocateValueClick(Sender: TObject);
begin
     DataSource1.DataSet.Locate('VALUE', eSearch.Text, []);
end;

procedure TForm1.btnLookupCalcClick(Sender: TObject);
begin
     eResult.Text:=VarToStr(DataSource1.DataSet.Lookup('PERIOD', eSearch.Text, 'CALC'));
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
     // Prepare a memorytable for detail.
     with kbmMemTable1 do
     begin
          LoadFromDataset(tDetailTemplate, true, true);
          IndexFields:='CustNo';
          MasterSource:=dsMaster;
          MasterFields:='CustNo';
     end;

     tMaster.Active:=not tMaster.Active;
     kbmMemTable1.Active:=tMaster.Active;
end;

procedure TForm1.kbmMemTable1CompressBlobStream(UnCompressedStream,
  CompressedStream: TStream);
begin
     if BlobCompression.Checked then
{$ifdef ZIP}
        ZIPCompressBlobStream(UnCompressedStream,CompressedStream)
{$else}
        LZHCompressBlobStream(UnCompressedStream,CompressedStream)
{$endif}
     else
        CompressedStream.CopyFrom(UnCompressedStream, 0);
end;

procedure TForm1.kbmMemTable1DecompressBlobStream(CompressedStream,
  DeCompressedStream: TStream);
begin
     if BlobCompression.Checked then
{$ifdef ZIP}
        ZIPDeCompressBlobStream(CompressedStream,DeCompressedStream)
{$else}
        LZHDeCompressBlobStream(CompressedStream,DeCompressedStream)
{$endif}
     else
         DeCompressedStream.CopyFrom(CompressedStream, 0);
end;

procedure TForm1.kbmMemTable1CompressSave(UnCompressedStream,
  CompressedStream: TStream);
begin
     Screen.Cursor := crHourglass;
     Application.ProcessMessages;
     try
        if LZHCompressed.Checked then
{$ifdef ZIP}
            ZIPCompressSave(UnCompressedStream,CompressedStream)
{$else}
            LZHCompressSave(UnCompressedStream,CompressedStream)
{$endif}
        else
            CompressedStream.CopyFrom(UnCompressedStream, 0);
     finally
        Screen.Cursor:=crDefault;
     end;
end;

procedure TForm1.kbmMemTable1DecompressLoad(CompressedStream,
  DeCompressedStream: TStream);
begin
     Screen.Cursor := crHourglass;
     Application.ProcessMessages;
     try
        if LZHCompressed.Checked then
{$ifdef ZIP}
            ZIPDeCompressLoad(CompressedStream,DeCompressedStream)
{$else}
            LZHDeCompressLoad(CompressedStream,DeCompressedStream)
{$endif}
        else
            DeCompressedStream.CopyFrom(CompressedStream, 0);
     finally
        Screen.Cursor:=crDefault;
     end;
end;

procedure TForm1.TabSheet3Enter(Sender: TObject);
var
   i:integer;
begin
     // Build list of fields to sort on.
     cbSortField.Clear;
     for i:=0 to kbmMemTable1.FieldCount-1 do
         cbSortField.Items.Add(kbmMemTable1.Fields[i].FieldName);
     cbSortField.ItemIndex:=0;
end;

procedure TForm1.btnSetRangeClick(Sender: TObject);
begin
     kbmMemTable1.IndexFields:='Period';
     kbmMemTable1.SetRange([50],[70]);
end;

procedure TForm1.btnCancelRangeClick(Sender: TObject);
begin
     kbmMemTable1.CancelRange;
end;

procedure TForm1.btnFindNearestClick(Sender: TObject);
begin
     kbmMemTable1.IndexFields:='VALUE';
     kbmMemTable1.SortOn('VALUE',[]);
     kbmMemtable1.FindNearest([eSearch.Text]);
end;

end.

