unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, RAMScrBr, ExtDlgs, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    OpenPictureDialog1: TOpenPictureDialog;
    Panel2: TPanel;
    Panel3: TPanel;
    HSB: TRAMScrollBar;
    VSB: TRAMScrollBar;
    PaintBox1: TPaintBox;
    RAMProgressBar1: TRAMProgressBar;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure SBChange(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure RAMProgressBar1Click(Sender: TObject);
  private
    Bitmap : TBitmap;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}
uses JPeg;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Bitmap:=TBitmap.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Bitmap.Free;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  J : TJpegImage;
begin
  if OpenPictureDialog1.Execute then begin
    if CompareText(ExtractFileExt(OpenPictureDialog1.FileName),'.JPG')=0 then begin
      J:=TJpegImage.Create;
      J.LoadFromFile(OpenPictureDialog1.FileName);
      Bitmap.Assign(J);
      J.Free;
    end else Bitmap.LoadFromFile(OpenPictureDialog1.FileName);
    HSB.Max:=Bitmap.Width;
    HSB.Position:=0;
    HSB.LargeChange:=PaintBox1.Width;
    VSB.Max:=Bitmap.Height;
    VSB.Position:=0;
    VSB.LargeChange:=PaintBox1.Height;
  end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  HSB.LargeChange:=PaintBox1.Width;
  VSB.LargeChange:=PaintBox1.Height;
end;

procedure TForm1.SBChange(Sender: TObject);
begin
  PaintBox1Paint(nil);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  PaintBox1.Canvas.Draw(-HSB.Position,-VSB.Position,Bitmap);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if RAMProgressBar1.Progress=100 then RAMProgressBar1.Progress:=0
  else RAMProgressBar1.Progress:=RAMProgressBar1.Progress+1;
  if Random(200)=0 then RAMProgressBar1.DrawProgress:=TProgressType(Random(4));
end;

procedure TForm1.RAMProgressBar1Click(Sender: TObject);
begin
  Timer1.Enabled:=not Timer1.Enabled;
end;

end.
 